﻿using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Pathing;
using Styx.Plugins;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AntiDismounter
{
    public class AntiDismounter : HBPlugin
    {

        private static float MIN_DIST = 15.0f;
        private bool on;

        public override void Initialize()
        {
            on = false;
        }

        public override void Pulse()
        {
            var me = StyxWoW.Me;
            if (!me.IsValid || !StyxWoW.IsInGame || !StyxWoW.IsInWorld)
                return;
            if (!me.Combat)
            {
                if (!on)
                {
                    Lua.DoString("oldCancelShapeshiftForm = CancelShapeshiftForm; CancelShapeshiftForm = function() end");
                    on = true;
                }
                if (me.IsMoving && WoWMovement.ClickToMoveInfo.ClickPos.Distance(me.Location) >= MIN_DIST && !me.Mounted && SpellManager.CanCast("Swift Flight Form"))
                {
                    SpellManager.Cast("Swift Flight Form");
                    Flightor.MoveTo(WoWMovement.ClickToMoveInfo.ClickPos);
                }
            }
            else if(me.Combat && on)
            {
                Lua.DoString("CancelShapeshiftForm = oldCancelShapeshiftForm;");
                on = false;
            }
        }

        public override string Name
        {
            get { return "AntiDismounter"; }
        }
        public override bool WantButton
        {
            get { return false; }
        }
        public override Version Version
        {
            get { return new Version(0, 1); }
        }
        public override string Author
        {
            get { return "..."; }
        }


    }
}